#include "factarray.h"

/* factArray() - takes a pointer to an empty int array
and an array size 'n', and populates the array
with the factorials from 0 to n-1.
*/
unsigned long long* factArray(unsigned long long dest[], unsigned int n)
{
  unsigned int a;
  dest[0] = 1;

  for (a = 1; a <= n; a++)
  {
    dest[a] = a * dest[a - 1];  /* computes a! */
  }

  return dest;
}
